diff --git a/sysprep/sysprep_operation.mli b/sysprep/sysprep_operation.mli
index 87a0b9a..16eee64 100644
--- a/sysprep/sysprep_operation.mli
+++ b/sysprep/sysprep_operation.mli
@@ -18,6 +18,8 @@
 
 (** Structure used to describe sysprep operations. *)
 
+val prog : string
+
 type flag = [ `Created_files ]
 
 type callback = Guestfs.guestfs -> string -> flag list
@@ -38,12 +40,15 @@ type operation = {
   pod_description : string option;
   (** POD-format long description, used for the man page. *)
 
-  extra_args : ((Arg.key * Arg.spec * Arg.doc) * string) list;
+  pod_notes : string option;
+  (** POD-format notes, used for the man page to describe any
+      problems, shortcomings or bugs with this operation. *)
+
+  extra_args : extra_arg list;
   (** Extra command-line arguments, if any.  eg. The [hostname]
       operation has an extra [--hostname] parameter.
 
-      Each element of the list is the argspec (see {!Arg.spec} etc.)
-      and the corresponding full POD documentation.
+      For a description of each list element, see {!extra_arg} below.
 
       You can decide the types of the arguments, whether they are
       mandatory etc. *)
@@ -75,6 +80,20 @@ type operation = {
       operation to work directly on block devices, LVs etc. *)
 }
 
+and extra_arg = {
+  extra_argspec : Arg.key * Arg.spec * Arg.doc;
+  (** The argspec.  See OCaml [Arg] module. *)
+
+  extra_pod_argval : string option;
+  (** The argument value, used only in the virt-sysprep man page. *)
+
+  extra_pod_description : string;
+  (** The long description, used only in the virt-sysprep man page. *)
+}
+
+val defaults : operation
+(** This is so operations can write [let op = { defaults with ... }]. *)
+
 val register_operation : operation -> unit
 (** Register an operation. *)
 
diff --git a/sysprep/sysprep_operation_bash_history.ml b/sysprep/sysprep_operation_bash_history.ml
index 6e1bd3f..f9efa47 100644
--- a/sysprep/sysprep_operation_bash_history.ml
+++ b/sysprep/sysprep_operation_bash_history.ml
@@ -33,16 +33,19 @@ let bash_history_perform g root =
   )
   else []
 
-let bash_history_op = {
-  name = "bash-history";
-  enabled_by_default = true;
-  heading = s_"Remove the bash history in the guest";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "bash-history";
+    enabled_by_default = true;
+    heading = s_"Remove the bash history in the guest";
+    pod_description = Some (s_"\
 Remove the bash history of user \"root\" and any other users
 who have a C<.bash_history> file in their home directory.");
-  extra_args = [];
-  perform_on_filesystems = Some bash_history_perform;
-  perform_on_devices = None;
+    pod_notes = Some (s_"\
+Currently this only looks in C</root> and C</home/*> for
+home directories, so users with home directories in other
+locations won't have the bash history removed.");
+    perform_on_filesystems = Some bash_history_perform;
 }
 
-let () = register_operation bash_history_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_blkid_tab.ml b/sysprep/sysprep_operation_blkid_tab.ml
index c75c3f3..fe9d10f 100644
--- a/sysprep/sysprep_operation_blkid_tab.ml
+++ b/sysprep/sysprep_operation_blkid_tab.ml
@@ -43,14 +43,12 @@ let blkid_tab_perform g root =
   )
   else []
 
-let blkid_tab_op = {
-  name = "blkid-tab";
-  enabled_by_default = true;
-  heading = s_"Remove blkid tab in the guest";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some blkid_tab_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "blkid-tab";
+    enabled_by_default = true;
+    heading = s_"Remove blkid tab in the guest";
+    perform_on_filesystems = Some blkid_tab_perform;
 }
 
-let () = register_operation blkid_tab_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_ca_certificates.ml b/sysprep/sysprep_operation_ca_certificates.ml
index 9b0d396..86a9c54 100644
--- a/sysprep/sysprep_operation_ca_certificates.ml
+++ b/sysprep/sysprep_operation_ca_certificates.ml
@@ -47,14 +47,12 @@ let ca_certificates_perform g root =
   )
   else []
 
-let ca_certificates_op = {
-  name = "ca-certificates";
-  enabled_by_default = false;
-  heading = s_"Remove CA certificates in the guest";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some ca_certificates_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "ca-certificates";
+    enabled_by_default = false;
+    heading = s_"Remove CA certificates in the guest";
+    perform_on_filesystems = Some ca_certificates_perform;
 }
 
-let () = register_operation ca_certificates_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_cron_spool.ml b/sysprep/sysprep_operation_cron_spool.ml
index 90eea03..1a036dd 100644
--- a/sysprep/sysprep_operation_cron_spool.ml
+++ b/sysprep/sysprep_operation_cron_spool.ml
@@ -21,7 +21,7 @@ open Common_gettext.Gettext
 
 module G = Guestfs
 
-let cron_spool_perform g root =
+let cron_spool_perform (g : Guestfs.guestfs) root =
   Array.iter g#rm_rf (g#glob_expand "/var/spool/cron/*");
   Array.iter g#rm (g#glob_expand "/var/spool/atjobs/*");
   Array.iter g#rm (g#glob_expand "/var/spool/atjobs/.SEQ");
@@ -33,14 +33,12 @@ let cron_spool_perform g root =
   Array.iter g#rm (g#glob_expand "/var/spool/at/spool/*");
   []
 
-let cron_spool_op = {
-  name = "cron-spool";
-  enabled_by_default = true;
-  heading = s_"Remove user at-jobs and cron-jobs";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some cron_spool_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "cron-spool";
+    enabled_by_default = true;
+    heading = s_"Remove user at-jobs and cron-jobs";
+    perform_on_filesystems = Some cron_spool_perform;
 }
 
-let () = register_operation cron_spool_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_dhcp_client_state.ml b/sysprep/sysprep_operation_dhcp_client_state.ml
index fcda3d5..69c506f 100644
--- a/sysprep/sysprep_operation_dhcp_client_state.ml
+++ b/sysprep/sysprep_operation_dhcp_client_state.ml
@@ -30,14 +30,12 @@ let dhcp_client_state_perform g root =
   );
   []
 
-let dhcp_client_state_op = {
-  name = "dhcp-client-state";
-  enabled_by_default = true;
-  heading = s_"Remove DHCP client leases";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some dhcp_client_state_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "dhcp-client-state";
+    enabled_by_default = true;
+    heading = s_"Remove DHCP client leases";
+    perform_on_filesystems = Some dhcp_client_state_perform;
 }
 
-let () = register_operation dhcp_client_state_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_dhcp_server_state.ml b/sysprep/sysprep_operation_dhcp_server_state.ml
index a713cbd..9ef2abf 100644
--- a/sysprep/sysprep_operation_dhcp_server_state.ml
+++ b/sysprep/sysprep_operation_dhcp_server_state.ml
@@ -25,14 +25,12 @@ let dhcp_server_state_perform g root =
   Array.iter g#rm_rf (g#glob_expand "/var/lib/dhcpd/*");
   []
 
-let dhcp_server_state_op = {
-  name = "dhcp-server-state";
-  enabled_by_default = true;
-  heading = s_"Remove DHCP server leases";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some dhcp_server_state_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "dhcp-server-state";
+    enabled_by_default = true;
+    heading = s_"Remove DHCP server leases";
+    perform_on_filesystems = Some dhcp_server_state_perform;
 }
 
-let () = register_operation dhcp_server_state_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_dovecot_data.ml b/sysprep/sysprep_operation_dovecot_data.ml
index 8a1fe49..c2004e8 100644
--- a/sysprep/sysprep_operation_dovecot_data.ml
+++ b/sysprep/sysprep_operation_dovecot_data.ml
@@ -32,14 +32,12 @@ let dovecot_data_perform g root =
   )
   else []
 
-let dovecot_data_op = {
-  name = "dovecot-data";
-  enabled_by_default = true;
-  heading = s_"Remove Dovecot (mail server) data";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some dovecot_data_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "dovecot-data";
+    enabled_by_default = true;
+    heading = s_"Remove Dovecot (mail server) data";
+    perform_on_filesystems = Some dovecot_data_perform;
 }
 
-let () = register_operation dovecot_data_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_firewall_rules.ml b/sysprep/sysprep_operation_firewall_rules.ml
new file mode 100644
index 0000000..cdb816e
--- /dev/null
+++ b/sysprep/sysprep_operation_firewall_rules.ml
@@ -0,0 +1,57 @@
+(* virt-sysprep
+ * Copyright (C) 2013 Fujitsu Limited.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+open Sysprep_operation
+open Common_gettext.Gettext
+
+module G = Guestfs
+
+let firewall_rules_perform g root =
+  let typ = g#inspect_get_type root in
+  if typ <> "windows" then (
+    let paths = [ "/etc/sysconfig/iptables";
+                  "/etc/firewalld/services/*";
+                  "/etc/firewalld/zones/*"; ] in
+    List.iter (
+      fun path ->
+        let files = g#glob_expand path in
+        Array.iter (
+          fun file ->
+            try g#rm file with G.Error _ -> ()
+        ) files;
+    ) paths;
+
+    []
+  )
+  else []
+
+let op = {
+  defaults with
+    name = "firewall-rules";
+    enabled_by_default = false;
+    heading = s_"Remove the firewall rules";
+    pod_description = Some (s_"\
+This removes custom firewall rules by removing C</etc/sysconfig/iptables>
+or custom firewalld configuration in C</etc/firewalld/*/*>.
+
+Note this is I<not> enabled by default since it may expose guests to
+exploits.  Use with care.");
+    perform_on_filesystems = Some firewall_rules_perform;
+}
+
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_firstboot.ml b/sysprep/sysprep_operation_firstboot.ml
index 1e70c65..6be3e92 100644
--- a/sysprep/sysprep_operation_firstboot.ml
+++ b/sysprep/sysprep_operation_firstboot.ml
@@ -26,38 +26,30 @@ module G = Guestfs
 
 let files = ref []
 
-let make_id_from_filename filename =
-  let ret = String.copy filename in
-  for i = 0 to String.length ret - 1 do
-    let c = String.unsafe_get ret i in
-    if not ((c >= 'a' && c <= 'z') ||
-               (c >= 'A' && c <= 'Z') ||
-               (c >= '0' && c <= '9')) then
-      String.unsafe_set ret i '-'
-  done;
-  ret
-
 let firstboot_perform g root =
   (* Read the files and add them using the {!Firstboot} module. *)
+  let files = List.rev !files in
+  let i = ref 0 in
   List.iter (
     fun filename ->
+      incr i;
+      let i = !i in
       let content = read_whole_file filename in
-      let basename = Filename.basename filename in
-      let id = make_id_from_filename basename in
-      Firstboot.add_firstboot_script g root id content
-  ) !files;
-  [ `Created_files ]
+      Firstboot.add_firstboot_script g root i content
+  ) files;
+  if files <> [] then [ `Created_files ] else []
 
-let firstboot_op = {
-  name = "firstboot";
+let op = {
+  defaults with
+    name = "firstboot";
 
-  (* enabled_by_default because we only do anything if the
-   * --firstboot parameter is used.
-   *)
-  enabled_by_default = true;
+    (* enabled_by_default because we only do anything if the
+     * --firstboot parameter is used.
+     *)
+    enabled_by_default = true;
 
-  heading = s_"Add scripts to run once at next boot";
-  pod_description = Some (s_"\
+    heading = s_"Add scripts to run once at next boot";
+    pod_description = Some (s_"\
 Supply one of more shell scripts (using the I<--firstboot> option).
 
 These are run the first time the guest boots, and then are
@@ -66,21 +58,22 @@ configuration that must run in the context of the guest
 operating system, for example C<yum update>.
 
 Output or errors from the scripts are written to
-C<~root/virt-sysprep-firstboot.log> (in the guest).
+C<~root/virt-sysprep-firstboot.log> (in the guest).");
 
+    pod_notes = Some (s_"\
 Currently this is only implemented for Linux guests using
-either System V init, or systemd.");
+either SysVinit-style scripts, Upstart or systemd.");
 
-  extra_args = [
-    ("--firstboot", Arg.String (fun s -> files := s :: !files),
-     s_"script" ^ " " ^ s_"run script once next time guest boots"),
-    s_"\
+    extra_args = [
+      { extra_argspec = "--firstboot", Arg.String (fun s -> files := s :: !files), s_"script" ^ " " ^ s_"run script once next time guest boots";
+        extra_pod_argval = Some "SCRIPT";
+        extra_pod_description = s_"\
 Run script(s) once next time the guest boots.  You can supply
 the I<--firstboot> option as many times as needed."
-  ];
+      }
+    ];
 
-  perform_on_filesystems = Some firstboot_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some firstboot_perform;
 }
 
-let () = register_operation firstboot_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_flag_reconfiguration.ml b/sysprep/sysprep_operation_flag_reconfiguration.ml
index 761d5eb..25abfef 100644
--- a/sysprep/sysprep_operation_flag_reconfiguration.ml
+++ b/sysprep/sysprep_operation_flag_reconfiguration.ml
@@ -29,16 +29,15 @@ let flag_reconfiguration g root =
   )
   else []
 
-let flag_reconfiguration_op = {
-  name = "flag-reconfiguration";
-  enabled_by_default = false;
-  heading = s_"Flag the system for reconfiguration";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "flag-reconfiguration";
+    enabled_by_default = false;
+    heading = s_"Flag the system for reconfiguration";
+    pod_description = Some (s_"\
 Note that this may require user intervention when the
 guest is booted.");
-  extra_args = [];
-  perform_on_filesystems = Some flag_reconfiguration;
-  perform_on_devices = None;
+    perform_on_filesystems = Some flag_reconfiguration;
 }
 
-let () = register_operation flag_reconfiguration_op;
+let () = register_operation op;
diff --git a/sysprep/sysprep_operation_hostname.ml b/sysprep/sysprep_operation_hostname.ml
index d38335e..3066623 100644
--- a/sysprep/sysprep_operation_hostname.ml
+++ b/sysprep/sysprep_operation_hostname.ml
@@ -26,81 +26,34 @@ module G = Guestfs
 
 let hostname = ref "localhost.localdomain"
 
-let hostname_perform g root =
-  let typ = g#inspect_get_type root in
-  let distro = g#inspect_get_distro root in
-  let major_version = g#inspect_get_major_version root in
+let hostname_perform (g : Guestfs.guestfs) root =
+  if Hostname.set_hostname g root !hostname then [ `Created_files ] else []
 
-  (* Replace <key>=... entry in file.  The code assumes it's a small,
-   * plain text file.
-   *)
-  let replace_line_in_file filename key value =
-    let content =
-      if g#is_file filename then (
-        let lines = Array.to_list (g#read_lines filename) in
-        let lines = List.filter (
-          fun line -> not (string_prefix line (key ^ "="))
-        ) lines in
-        let lines = lines @ [sprintf "%s=%s" key value] in
-        String.concat "\n" lines ^ "\n"
-      ) else (
-        sprintf "%s=%s\n" key value
-      ) in
-    g#write filename content
-  in
+let op = {
+  defaults with
+    name = "hostname";
+    enabled_by_default = true;
+    heading = s_"Change the hostname of the guest";
 
-  let update_etc_hostname () =
-    g#write "/etc/hostname" !hostname
-  in
-
-  let update_etc_machine_info () =
-    replace_line_in_file "/etc/machine-info" "PRETTY_HOSTNAME" !hostname
-  in
-
-  match typ, distro, major_version with
-  (* Fedora 18 (hence RHEL 7+) changed to using /etc/hostname
-   * (RHBZ#881953, RHBZ#858696).  We may also need to modify
-   * /etc/machine-info (RHBZ#890027).
-   *)
-  | "linux", "fedora", v when v >= 18 ->
-    update_etc_hostname ();
-    update_etc_machine_info ();
-    [ `Created_files ]
-  | "linux", ("rhel"|"centos"|"scientificlinux"|"redhat-based"), v when v >= 7 ->
-    update_etc_hostname ();
-    update_etc_machine_info ();
-    [ `Created_files ]
-  | "linux", ("debian"|"ubuntu"), _ ->
-    update_etc_hostname ();
-    [ `Created_files ]
-
-  | "linux", ("fedora"|"rhel"|"centos"|"scientificlinux"|"redhat-based"), _ ->
-    replace_line_in_file "/etc/sysconfig/network" "HOSTNAME" !hostname;
-    [ `Created_files ]
-
-  | "linux", ("opensuse"|"sles"|"suse-based"), _ ->
-    g#write "/etc/HOSTNAME" !hostname;
-    [ `Created_files ]
-
-  | _ -> []
-
-let hostname_op = {
-  name = "hostname";
-  enabled_by_default = true;
-  heading = s_"Change the hostname of the guest";
-  pod_description = Some (s_"\
+    pod_description = Some (s_"\
 This operation changes the hostname of the guest to the value
 given in the I<--hostname> parameter.
 
 If the I<--hostname> parameter is not given, then the hostname is changed
 to C<localhost.localdomain>.");
-  extra_args = [
-    ("--hostname", Arg.Set_string hostname, s_"hostname" ^ " " ^ s_"New hostname"),
-    s_"\
+
+    pod_notes = Some (s_"\
+Currently this can only set the hostname on Linux guests.");
+
+    extra_args = [
+      { extra_argspec = "--hostname", Arg.Set_string hostname, s_"hostname" ^ " " ^ s_"New hostname";
+        extra_pod_argval = Some "HOSTNAME";
+        extra_pod_description = s_"\
 Change the hostname.  If not given, defaults to C<localhost.localdomain>."
-  ];
-  perform_on_filesystems = Some hostname_perform;
-  perform_on_devices = None;
+      }
+    ];
+
+    perform_on_filesystems = Some hostname_perform;
 }
 
-let () = register_operation hostname_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_kerberos_data.ml b/sysprep/sysprep_operation_kerberos_data.ml
index 1e120aa..0652719 100644
--- a/sysprep/sysprep_operation_kerberos_data.ml
+++ b/sysprep/sysprep_operation_kerberos_data.ml
@@ -40,14 +40,12 @@ let kerberos_data_perform g root =
   )
   else []
 
-let kerberos_data_op = {
-  name = "kerberos-data";
-  enabled_by_default = false;
-  heading = s_"Remove Kerberos data in the guest";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some kerberos_data_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "kerberos-data";
+    enabled_by_default = false;
+    heading = s_"Remove Kerberos data in the guest";
+    perform_on_filesystems = Some kerberos_data_perform;
 }
 
-let () = register_operation kerberos_data_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_logfiles.ml b/sysprep/sysprep_operation_logfiles.ml
index 88b0977..8994af9 100644
--- a/sysprep/sysprep_operation_logfiles.ml
+++ b/sysprep/sysprep_operation_logfiles.ml
@@ -40,7 +40,6 @@ let globs = List.sort compare [
   "/var/log/wtmp*";
   "/var/log/apache2/*_log";
   "/var/log/apache2/*_log-*";
-  "/var/log/audit/audit.log";
   "/var/log/ntp";
 
   (* logfiles configured by /etc/logrotate.d/* *)
@@ -80,6 +79,15 @@ let globs = List.sort compare [
 
   (* man pages cache *)
   "/var/cache/man/*";
+
+  (* log file of sysstat *)
+  "/var/log/sa/*";
+
+  (* log file of gdm *)
+  "/var/log/gdm/*";
+
+  (* log file of ntp *)
+  "/var/log/ntpstats/*";
 ]
 let globs_as_pod = String.concat "\n" (List.map ((^) " ") globs)
 
@@ -90,18 +98,17 @@ let logfiles_perform g root =
   );
   []
 
-let logfiles_op = {
-  name = "logfiles";
-  enabled_by_default = true;
-  heading = s_"Remove many log files from the guest";
-  pod_description = Some (
-    sprintf (f_"\
+let op = {
+  defaults with
+    name = "logfiles";
+    enabled_by_default = true;
+    heading = s_"Remove many log files from the guest";
+    pod_description = Some (
+      sprintf (f_"\
 On Linux the following files are removed:
 
 %s") globs_as_pod);
-  extra_args = [];
-  perform_on_filesystems = Some logfiles_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some logfiles_perform;
 }
 
-let () = register_operation logfiles_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_lvm_uuids.ml b/sysprep/sysprep_operation_lvm_uuids.ml
index b116d66..7790d0b 100644
--- a/sysprep/sysprep_operation_lvm_uuids.ml
+++ b/sysprep/sysprep_operation_lvm_uuids.ml
@@ -38,16 +38,15 @@ let rec lvm_uuids_perform g root =
   );
   []
 
-let lvm_uuids_op = {
-  name = "lvm-uuids";
-  enabled_by_default = true;
-  heading = s_"Change LVM2 PV and VG UUIDs";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "lvm-uuids";
+    enabled_by_default = true;
+    heading = s_"Change LVM2 PV and VG UUIDs";
+    pod_description = Some (s_"\
 On Linux guests that have LVM2 physical volumes (PVs) or volume groups (VGs),
 new random UUIDs are generated and assigned to those PVs and VGs.");
-  extra_args = [];
-  perform_on_filesystems = None;
-  perform_on_devices = Some lvm_uuids_perform;
+    perform_on_devices = Some lvm_uuids_perform;
 }
 
-let () = register_operation lvm_uuids_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_machine_id.ml b/sysprep/sysprep_operation_machine_id.ml
index c826da4..5eadea4 100644
--- a/sysprep/sysprep_operation_machine_id.ml
+++ b/sysprep/sysprep_operation_machine_id.ml
@@ -31,18 +31,17 @@ let machine_id_perform g root =
   )
   else []
 
-let machine_id_op = {
-  name = "machine-id";
-  enabled_by_default = true;
-  heading = s_"Remove the local machine ID";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "machine-id";
+    enabled_by_default = true;
+    heading = s_"Remove the local machine ID";
+    pod_description = Some (s_"\
 The machine ID is usually generated from a random source during system
 installation and stays constant for all subsequent boots.  Optionally,
 for stateless systems it is generated during runtime at boot if it is
 found to be empty.");
-  extra_args = [];
-  perform_on_filesystems = Some machine_id_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some machine_id_perform;
 }
 
-let () = register_operation machine_id_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_mail_spool.ml b/sysprep/sysprep_operation_mail_spool.ml
index 1b0cbe3..fa2b4e7 100644
--- a/sysprep/sysprep_operation_mail_spool.ml
+++ b/sysprep/sysprep_operation_mail_spool.ml
@@ -30,14 +30,12 @@ let mail_spool_perform g root =
   ];
   []
 
-let mail_spool_op = {
-  name = "mail-spool";
-  enabled_by_default = true;
-  heading = s_"Remove email from the local mail spool directory";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some mail_spool_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "mail-spool";
+    enabled_by_default = true;
+    heading = s_"Remove email from the local mail spool directory";
+    perform_on_filesystems = Some mail_spool_perform;
 }
 
-let () = register_operation mail_spool_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_net_hostname.ml b/sysprep/sysprep_operation_net_hostname.ml
index 37fb78b..a540357 100644
--- a/sysprep/sysprep_operation_net_hostname.ml
+++ b/sysprep/sysprep_operation_net_hostname.ml
@@ -43,16 +43,15 @@ let net_hostname_perform g root =
 
   | _ -> []
 
-let net_hostname_op = {
-  name = "net-hostname";
-  enabled_by_default = true;
-  heading = s_"Remove HOSTNAME in network interface configuration";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "net-hostname";
+    enabled_by_default = true;
+    heading = s_"Remove HOSTNAME in network interface configuration";
+    pod_description = Some (s_"\
 For Fedora and Red Hat Enterprise Linux,
 this is removed from C<ifcfg-*> files.");
-  extra_args = [];
-  perform_on_filesystems = Some net_hostname_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some net_hostname_perform;
 }
 
-let () = register_operation net_hostname_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_net_hwaddr.ml b/sysprep/sysprep_operation_net_hwaddr.ml
index fe7fac0..6409767 100644
--- a/sysprep/sysprep_operation_net_hwaddr.ml
+++ b/sysprep/sysprep_operation_net_hwaddr.ml
@@ -43,16 +43,15 @@ let net_hwaddr_perform g root =
 
   | _ -> []
 
-let net_hwaddr_op = {
-  name = "net-hwaddr";
-  enabled_by_default = true;
-  heading = s_"Remove HWADDR (hard-coded MAC address) configuration";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "net-hwaddr";
+    enabled_by_default = true;
+    heading = s_"Remove HWADDR (hard-coded MAC address) configuration";
+    pod_description = Some (s_"\
 For Fedora and Red Hat Enterprise Linux,
 this is removed from C<ifcfg-*> files.");
-  extra_args = [];
-  perform_on_filesystems = Some net_hwaddr_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some net_hwaddr_perform;
 }
 
-let () = register_operation net_hwaddr_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_pacct_log.ml b/sysprep/sysprep_operation_pacct_log.ml
index f2d47c7..10dc25f 100644
--- a/sysprep/sysprep_operation_pacct_log.ml
+++ b/sysprep/sysprep_operation_pacct_log.ml
@@ -45,16 +45,15 @@ let pacct_log_perform g root =
 
   | _ -> []
 
-let pacct_log_op = {
-  name = "pacct-log";
-  enabled_by_default = true;
-  heading = s_"Remove the process accounting log files";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "pacct-log";
+    enabled_by_default = true;
+    heading = s_"Remove the process accounting log files";
+    pod_description = Some (s_"\
 The system wide process accounting will store to the pacct
 log files if the process accounting is on.");
-  extra_args = [];
-  perform_on_filesystems = Some pacct_log_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some pacct_log_perform;
 }
 
-let () = register_operation pacct_log_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_package_manager_cache.ml b/sysprep/sysprep_operation_package_manager_cache.ml
index 69c9245..586490e 100644
--- a/sysprep/sysprep_operation_package_manager_cache.ml
+++ b/sysprep/sysprep_operation_package_manager_cache.ml
@@ -18,6 +18,7 @@
 
 open Sysprep_operation
 open Common_gettext.Gettext
+open Common_utils
 
 module G = Guestfs
 
@@ -26,24 +27,22 @@ let package_manager_cache_perform g root =
   let cache_dirs =
     match packager with
     | "zypper" ->
-      Some (g#glob_expand "/var/cache/zypp*/*")
+      Some (Array.to_list (g#glob_expand "/var/cache/zypp*"))
     | "yum" ->
-      Some (g#glob_expand "/var/cache/yum/*")
+      Some [ "/var/cache/yum/" ]
     | "apt" ->
-      Some (g#glob_expand "/var/cache/apt/archives/*")
+      Some [ "/var/cache/apt/archives/" ]
     | _ -> None in
   match cache_dirs with
-  | Some dirs -> Array.iter g#rm_rf dirs; []
+  | Some dirs -> List.iter (rm_rf_only_files g) dirs; []
   | _ -> []
 
-let package_manager_cache_op = {
-  name = "package-manager-cache";
-  enabled_by_default = true;
-  heading = s_"Remove package manager cache";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some package_manager_cache_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "package-manager-cache";
+    enabled_by_default = true;
+    heading = s_"Remove package manager cache";
+    perform_on_filesystems = Some package_manager_cache_perform;
 }
 
-let () = register_operation package_manager_cache_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_pam_data.ml b/sysprep/sysprep_operation_pam_data.ml
index 931890d..82c88f9 100644
--- a/sysprep/sysprep_operation_pam_data.ml
+++ b/sysprep/sysprep_operation_pam_data.ml
@@ -40,14 +40,12 @@ let pam_data_perform g root =
   )
   else []
 
-let pam_data_op = {
-  name = "pam-data";
-  enabled_by_default = true;
-  heading = s_"Remove the PAM data in the guest";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some pam_data_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "pam-data";
+    enabled_by_default = true;
+    heading = s_"Remove the PAM data in the guest";
+    perform_on_filesystems = Some pam_data_perform;
 }
 
-let () = register_operation pam_data_op
+let () = register_operation op
